----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    22:45:46 04/14/2010 
-- Design Name: 
-- Module Name:    ClockDivider - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ClockDivider is
    Port ( 
			  fastclkin : in  STD_LOGIC;
           fastclkby2 : out  STD_LOGIC;
           fastclkbydiv : out  STD_LOGIC;
			  divenable: in std_logic;
           clklatch : in  STD_LOGIC_VECTOR (4 downto 0);
			  reset : in STD_LOGIC
			  );
end ClockDivider;

architecture Behavioral of ClockDivider is
			signal bydiv : std_logic;
			signal by2 : std_logic;
			signal clkcounter : std_logic_vector(3 downto 0) := "1111";
begin
			
		fastclkby2 <= by2;
		fastclkbydiv <= bydiv;
		
		Timing: process(fastclkin, reset)
		begin
			if (reset = '0') then
				by2 <= '0';
			elsif (falling_edge(fastclkin)) then
				by2 <= not(by2);
			end if;
		end process;
				
		 -- master timing
		 Master_Timing: process(fastclkin, reset, divenable, clklatch)
		 begin
					if (reset = '0' or divenable = '0') then
					
							  clkcounter <= clklatch(4 downto 1);
							  bydiv <= '0';
							  
					elsif (falling_edge(fastclkin)) then

							  if (clkcounter = 0) then
									if (bydiv = '0') then
										 clkcounter <= clklatch(4 downto 1);
									else 
										 clkcounter <= clklatch(4 downto 1) - not(clklatch(0));
									end if;
									bydiv <= not(bydiv);
							  else
									clkcounter <= clkcounter - 1;
							  end if;
					end if;
		 end process Master_Timing;

end Behavioral;

