----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    23:12:36 04/14/2010 
-- Design Name: 
-- Module Name:    ClockShift - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ClockShift is
    Port ( 
			  phi : in  STD_LOGIC;
           fastclk : in  STD_LOGIC;
			  fastclkby2 : in STD_LOGIC;
			  shortdelay : in std_logic;
           phidelayed : out  STD_LOGIC;
           pulser : out  STD_LOGIC;
           pulsew : out  STD_LOGIC
			);
end ClockShift;

architecture Behavioral of ClockShift is

		-- clock shift register
		signal phi0D1: std_logic := '0';
		signal phi0D2: std_logic := '0';
		signal phi0D3: std_logic := '0';
		signal phi0D4: std_logic := '0';
		signal phi0D5: std_logic := '0';
		signal phi0D6: std_logic := '0';
		signal phi0D7: std_logic := '0';
		signal phi0D8: std_logic := '0';
		signal phi0D9: std_logic := '0';
		signal phi0DA: std_logic := '0';
		signal phi0DB: std_logic := '0';
		signal phi0DC: std_logic := '0';
		signal phi0DD: std_logic := '0';
		
		signal phi0D1a: std_logic := '0';
		signal phi0D2a: std_logic := '0';
		signal phi0D3a: std_logic := '0';
		signal phi0D4a: std_logic := '0';
		signal phi0D5a: std_logic := '0';
		signal phi0D6a: std_logic := '0';
		signal phi0D7a: std_logic := '0';

begin

                Delay1: process(fastclk, phi)
                begin
                        if (falling_edge(fastclk)) then
                                phi0D1 <= phi;
                                phi0D2 <= phi0D1;
                                phi0D3 <= phi0D2;
                                phi0D4 <= phi0D3;
                                phi0D5 <= phi0D4;
                                phi0D6 <= phi0D5;
										  phi0D7 <= phi0D6;
										  phi0D8 <= phi0D7;
                        end if;
                end process Delay1;

                Delay2: process(fastclk, phi)
                begin
                        if (rising_edge(fastclk)) then
                                phi0D1a <= phi0D1;
                                phi0D2a <= phi0D2;
                                phi0D3a <= phi0D3;
                                phi0D4a <= phi0D4;
                                phi0D5a <= phi0D5;
										  phi0D6a <= phi0D6;
										  phi0D7a <= phi0D7;
                        end if;
                end process;

					 Delay3: process(fastclkby2, phi0D8)
					 begin
						if (rising_edge(fastclkby2)) then
							phi0D9 <= phi0D8;
							phi0DA <= phi0D9;
							phi0DB <= phi0DA;
							phi0DC <= phi0DB;
							phi0DD <= phi0DC;
						end if;
					end process;
					
					-- on the falling edge of this signal slowdetected is checked and a slow access is started
					-- if it is set. should allow for 120-150ns before rising edge of phi2, for address setup times					
					-- if using D6, 2Mhz would partially miss due to jitter and get slowed down (but still work)
					phidelayed <= (shortdelay and phi0D7) or (not(shortdelay) and phi0DD);
               --phidelayed <= phi0D6; -- 
				 
					-- use max D1a, as using D1 would shorten slowdone so that it would partially be missed downstream
					pulser <= phi0D3 and not(phi0D2); -- ends slow read access; using D2/D1 gives errors at higher speeds
					pulsew <= phi0D3 and not(phi0D2); -- ends slow write access

end Behavioral;

