----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    21:10:29 04/15/2010 
-- Design Name: 
-- Module Name:    ControlRegister - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ControlRegister is
    Port ( data : inout  STD_LOGIC_VECTOR (7 downto 0);
           clk : in  STD_LOGIC;
			  sel : in STD_LOGIC;
			  addr : in STD_LOGIC;
			  rnw : in STD_LOGIC;
           reset : in  STD_LOGIC;
           bootromin : in  STD_LOGIC;
			  auxconf : in std_logic;
			  
			  -- control register
           wprotect : out  STD_LOGIC_VECTOR (1 downto 0);
           hidebogus : out  STD_LOGIC;
           bootrom : out  STD_LOGIC;
           prgrom : out  STD_LOGIC;
			  slow64k : out STD_LOGIC;
			  slowclk : out STD_LOGIC;
			  fastvread : out STD_LOGIC;
			  
			  -- clock control
           clklatch : out  STD_LOGIC_VECTOR (4 downto 0);
			  fastmode : out std_logic
	);

end ControlRegister;

architecture Behavioral of ControlRegister is

begin

		DoWriteAccess: process(clk, rnw, reset, bootromin, data, auxconf)
		begin
			if (reset = '0') then
				-- control register
				fastvread <= '0';
				slowclk <= '1';
				slow64k <= '1';
				bootrom <= bootromin;
				prgrom <= '0';
				wprotect <= "00";
				hidebogus <= '0';
				-- clock control
				clklatch <= "01111";
				fastmode <= '1'; --auxconf;
				
			elsif (falling_edge(clk) and rnw = '0') then
				if (sel = '1') then
					if (addr = '1') then
							-- write $00exxf
							--clkdiv <= data(1 downto 0);
							wprotect <= data(1 downto 0);
							fastvread <= data(2);
							hidebogus <= data(3);
							slowclk <= data(4);
							slow64k <= data(5);
							bootrom <= data(6);
							prgrom <= data(7);
					elsif (addr = '0') then
							-- write $00exxe
							if (data(3 downto 0) <= "00011") then
								clklatch <= "00011";
							else
								clklatch <= data(4 downto 0);
							end if;
							fastmode <= data(7);
					end if;
				end if;
			end if;
		end process DoWriteAccess;

--		DoReadAccess: process(cpuclkint, phi0D2, reset)
--		begin
--			if (cpuclkint = '0') then 
--				cpudata <= "ZZZZZZZZ";
--				myregister <= '0';
--			elsif (rising_edge(phi0D2) and cpurnw = '1') then
--				if (islow64k = '1'
--						and isio = '1'
--						and cpuaddr_ismyio = '0') then
--					 case cpuaddrin_16 is
--						when "1111" =>
--							-- read $00efff
--							myregister <= '1';
--							cpudata <= (prgrom, bootrom, slow64k, slowonly, wprotect(1), wprotect(0), clkdiv(1), clkdiv(0));
--						when others =>
--							cpudata <= "ZZZZZZZZ";
--							myregister <= '0';
--					end case;
--				end if;
--			end if;
--		end process DoReadAccess;


end Behavioral;

